/***************************************************************************
                          InitSDL.h  -  description
                             -------------------
    begin                : Sat May 10 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __INITSDL_H__
#define __INITSDL_H__

#include <spritelib/spritelib.h>
#include <SDL/SDL_mixer.h>

#ifdef __cplusplus
extern "C" {
#endif

/*! \brief Default bits per pixel. */
#define DEFAULT_BPP 24

/*! \brief Audio samplerate */
#define AUDIO_RATE 44100
/*! \brief Audio format - 8/16 bit */
#define AUDIO_TYPE AUDIO_S16
/*! \brief Number of audio channels, 1=mono 2=stereo */
#define AUDIO_CHAN 2
/*! \brief Audio buffersize.  Too much means lag, too little means clicking. */
#define AUDIO_BUF  2048

/*! \brief Attempts to switch to/from fullscreen video. */
int ToggleFullscreen();
/*! \brief Initializes SDL audio and video, and SDL_mixer. */
int Init(int x, int y, int fullscreen);
/*! \brief Deinitializes SDL_mixer, then SDL. */
void Quit();

/*! \brief Convenience function, pushes a SDL_USEREVENT onto the que */
void PushUserEvent(int code, void *data1=NULL, void *data2=NULL);

#ifdef __cplusplus
}
#endif

#endif/*__INITSDL_H__*/
