/***************************************************************************
                          Sample.cpp  -  description
                             -------------------
    begin                : Mon May 12 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "Sample.h"


int Mixer::Play(Mix_Chunk *data, Uint8 dist, Uint16 pos, int loop, int chan)
{
  int c=-1;

  if(data==NULL) return(0);

  c=Mix_PlayChannel(chan,data,loop);
  if(c<0)
  {
    return(0);
  }
  else
  {
    channels[c]=data;
    Mix_SetPosition(c,pos,dist);
    return(1);
  }
}


Mixer::Mixer(int max_channels)
{
  int n=-1;
  maxchans=max_channels;

  Mix_AllocateChannels(maxchans);

  channels = new Mix_Chunk *[maxchans];
  for(n=0; n<maxchans; n++)
  {
    channels[n]=NULL;
  }
}

int Mixer::Playing()
{
  int n=-1;

  for(n=0; n<maxchans; n++)
  {
    if(Playing(n)) return(1);
  }

  return(0);
}

int Mixer::Playing(Mix_Chunk *chunk)
{
  int n=-1;

  for(n=0; n<maxchans; n++)
  if(channels[n]==chunk)
  {
    if(Playing(n))
    {
      return(1);
    }
  }

  return(0);  
}


int Mixer::Stop()
{
  int retval=0,n=-1;

  for(n=0; n<maxchans; n++)
  {
    retval|=Stop(n);
  }

  return(retval);
}

int Mixer::Stop(int n)
{
  if(Playing(n))
  {
    Mix_HaltChannel(n);
    channels[n]=NULL;
    return(1);
  }
  else
  {
    return(0);
  }
}

int Mixer::Playing(int n)
{
  if(Mix_Playing(n))
  {
    return(1);
  }
  else
  {
    channels[n]=NULL;
    return(0);
  }
}

Mixer::~Mixer()
{
  Stop();
  delete channels;
}
