/***************************************************************************
                          StringSprite.h  -  description
                             -------------------
    begin                : Fri Jun 6 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __STRINGSPRITE_H__
#define __STRINGSPRITE_H__

#ifndef __cplusplus
#error "Requires C++ compilation"
#endif

#include <stdarg.h>
#include <spritelib/sprite.h>

class StringSprite:public Sprite
{
public:
  StringSprite();
  StringSprite(SDL_Surface *font_in, int width_in, int lines_in);
  void Init(SDL_Surface *font_in, int width_in, int lines_in);
  void Clear();
  int Print(const char *cmdstr, ...);      
    
private:
  SDL_Surface *CreateSurface(int width, int height);
  
  inline Rect GetRect(char c)
  {
    Rect r=charblock;
    r.x=(c%16)*r.w;
    r.y=(c/16)*r.h;
    return(r);
  }
  
  SDL_Surface *font;
  Rect         charblock;
  int          width,lines;
};

#endif/*__STRINGSPRITE_H__*/
